/*
    SPDX-FileCopyrightText: 2024 Sergey Katunin <sulmpx60@yandex.ru>

    SPDX-License-Identifier: LGPL-2.1-or-later
*/


#ifndef RTF_EXTRACTOR_H
#define RTF_EXTRACTOR_H

#include "extractorplugin.h"


namespace RtfReader
{
    class TextDocumentRtfOutput;
}

class QTextDocument;

namespace KFileMetaData
{

class RtfExtractor : public ExtractorPlugin
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.kde.kf5.kfilemetadata.ExtractorPlugin"
                      FILE "rtfextractor.json")
    Q_INTERFACES(KFileMetaData::ExtractorPlugin)

public:
    explicit RtfExtractor(QObject* parent = nullptr);

    QStringList mimetypes() const override;
    void extract(ExtractionResult* result) override;
private:
    void parseMetaData(RtfReader::TextDocumentRtfOutput *output, ExtractionResult *result);
    void extractPlainText(const QTextDocument &doc, ExtractionResult *result);
};
}

#endif // RTF_EXTRACTOR_H
